﻿using Amogulator.Suslang;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;

namespace Amogulator;
public partial class AmogulatorVM : ObservableObject {

    [ObservableProperty]
    private string output = "test", input = "2 + 3";

    [RelayCommand]
    private void run() {
        var ast = new Parser(this.Input, new Lexer(this.Input)).parseExpr();
        var compiler = new Compiler();
        compiler.compileExpr(ast);
        var bytecode = compiler.result();
        var vm = new VM(bytecode);
        vm.evaluate();
        this.Output = ast.astString(0) + "\n\nresult = " + ((IntValue) vm.stack.Peek()).value;
    }

}
